%See start_callback of batchTrack_gui.m for more!
crossdata=[];
for i=1:length(filelist)
    t=1;
    attempt=1;
    disp(['Processing frame ' num2str(i) ' of ' num2str(length(filelist))]);
    file=filelist{i};
    done=0;
    while ~done %loop until you have a proper set for xcl and ycl
        drawnow
        try
            
            if ~isempty(prevX) %ALL ITERATIONS AFTER THE FIRST
                [xclOrig,yclOrig,xcross,ycross]=mainProcess3(file,0,clow,chigh,threshold(t),prevX,prevY);    %run automated search for spline
            else %FIRST ITERATION
                [xclOrig,yclOrig,xcross,ycross]=mainProcess3(file,0,clow,chigh,threshold(t));
            end

            if i==1 && ~exist('inBatchMode') %FIRST ITERATION - let the user check the computer's work if not in batch mode
                prevX=[]; prevY=[];
                fig=figure;
                imshow(imread(file));
                hold on
                plot(xclOrig,480-yclOrig+1,'c.');
                plot(xclOrig(1),480-yclOrig(1)+1,'cx','MarkerSize',12);
                hold off
                choice = questdlg('Swap?','Initial Head Recognition','Keep','Swap','Keep');
                switch choice
                    case 'Keep'
                    case 'Swap'
                        [xclOrig,yclOrig,xcross,ycross]=mainProcess3(file,1,clow,chigh,threshold(t));
                end
                delete(fig)
            end
            
            [xcl,ycl]=compensateForStage(xclOrig,yclOrig,i,stageMovement,frameRate,calibx,caliby);

            l=wormLength(xcl,ycl); %check the head and tail positions
            if i~=1
                if ptDist(xcl(1),ycl(1),lastHeadX,lastHeadY)>ptDist(xcl(end),ycl(end),lastHeadX,lastHeadY)
                    fprintf('\n\nSwapping head with tail\n')
                    [xclOrig,yclOrig,xcross,ycross]=mainProcess3(file,1,clow,chigh,threshold(t),prevX,prevY);
                    [xcl,ycl]=compensateForStage(xclOrig,yclOrig,i,stageMovement,frameRate,calibx,caliby);
                    disp('Swapped head and tail')
                end
            end

            if sum(xclOrig)~=0 && sum(yclOrig)~=0 %if an acceptable spline is found, save it as prevX/prevY
                prevX=xclOrig;
                prevY=yclOrig;
            end
            lastHeadX=xcl(1);lastHeadY=ycl(1);  %store the last head position for the next iteration of the loop
            done=1;
            fprintf('Successfully produced spline\n\n\n');
            
        catch
            disp('Analysis failed--Trying again')
            disp(['Attempt: ' num2str(attempt)])
            attempt=attempt+1;
            if attempt==2
                t=2;    
                %t is the variable that describes which multiplier of threshold to use, typically 0.9, then 1.1, then 0.8, then 1.2.
            elseif attempt==3
                t=3;
            elseif attempt==4
                t=4;
            elseif attempt==5
                t=5;
            elseif attempt>5   %skip if 5 attempts fail
                xcl=zeros(1,13);	%come back later to do these manually. everything gets set to zero
                ycl=zeros(1,13);
                xclOrig=xcl;
                yclOrig=ycl;
                done=1;
                manual=1;
                fprintf('\n\n');
            end
        end
        
        if exist('xcl') || mean(xcl==[0 0 0 0 0 0 0 0 0 0 0 0 0])~=1
            xcl=xcl*calibx;
            ycl=ycl*caliby;
            splineData(2*i-1:2*i,:)=[xcl;ycl];
            splineDataOrig(2*i-1:2*i,:)=[xclOrig;yclOrig];
        end
        
        


%At this point xclOrig/yclOrig are in pixels, while xcl/ycl are in
%micrometers

%Must make sure all further operations respect this convention:
%Orig means uncompensated and uncalibrated
%unsuffixed means compensated and calibrated

    end
    crossdata=[crossdata; xcross; ycross];
end
