function varargout = analysis_gui(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @analysis_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @analysis_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

function analysis_gui_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;

guidata(hObject, handles);

function varargout = analysis_gui_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;

function splinePath_Callback(hObject, eventdata, handles)

function splinePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function browseSpline_Callback(hObject, eventdata, handles)
comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end
persistent lastPath

if isempty(lastPath)
    [filename pathname]=uigetfile('*.txt','Open Spline File');
else
    [filename pathname]=uigetfile('*.txt','Open Spline File',lastPath);
end

if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.splinePath,'String',[pathname filename]);
    wormName=filename(1:end-16);
    stageName=[pathname wormName slash wormName '.txt'];
    set(handles.stagePath,'String',stageName);
    lastPath=pathname;
end

function frameRate_Callback(hObject, eventdata, handles)

function frameRate_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function bendsFreqRms_Callback(hObject, eventdata, handles)
getAnalysisProperties
% splinePath=get(handles.splinePath,'String');
bendNumber=str2double(get(handles.bendNumber,'String'));
fs=str2double(get(handles.frameRate,'String'));
rms=ang(splineFile,bendNumber,framesToAnalyze);
[freq,time,head]=fftscript(splineFile,bendNumber,fs,framesToAnalyze,1);
freq=round(freq*100)/100;
rms=round(rms*100)/100;

set(handles.bendMessages,'String',['Freq: ' num2str(freq) ' Hz; RMS: ' num2str(rms) ' deg'])

function bendNumber_Callback(hObject, eventdata, handles)

function bendNumber_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function maxHeadBend_Callback(hObject, eventdata, handles)
getAnalysisProperties
% splinePath=get(handles.splinePath,'String');
% splineData=load(splinePath);
bendNumber=str2double(get(handles.bendNumber,'String'));
fs=str2double(get(handles.frameRate,'String'));
[freq,time,head]=fftscript(splineFile,bendNumber,fs,framesToAnalyze);
exc=bendCursor_gui(time,head);
exc=round(exc*100)/100;
set(handles.bendMessages,'String',['Max Bend: ' num2str(exc) ' deg']);

function plotBend_Callback(hObject, eventdata, handles)
getAnalysisProperties
% splinePath=get(handles.splinePath,'String');
bendNumber=str2double(get(handles.bendNumber,'String'));
fs=str2double(get(handles.frameRate,'String'));
[freq,time,head]=fftscript(splineFile,bendNumber,fs,framesToAnalyze);
fig=figure;
plot(time,head)
title('Bend Trace')
xlabel('Time (sec)');
ylabel('Bending Angle (deg)')



function stagePath_Callback(hObject, eventdata, handles)


function stagePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function browseStage_Callback(hObject, eventdata, handles)
[filename pathname]=uigetfile('*.txt','Open Stage File');
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.stagePath,'String',[pathname filename]);
end



function splinePoint_Callback(hObject, eventdata, handles)


function splinePoint_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function plotPath_Callback(hObject, eventdata, handles)
getAnalysisProperties
fig=wormLocomotion('Plot',splineFile,stageFile,frameRate,calibx,caliby,point,oldStyle,framesToAnalyze);

function calibx_Callback(hObject, eventdata, handles)

function calibx_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function caliby_Callback(hObject, eventdata, handles)

function caliby_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function sumOfBends_Callback(hObject, eventdata, handles)
getAnalysisProperties
% splinePath=get(handles.splinePath,'String');
[sumOfBends]=averageSumOfBends(splineFile,framesToAnalyze);
sumOfBends=round(sumOfBends*100)/100;
set(handles.bendMessages,'String',['Average Sum of Bends: ' num2str(sumOfBends) ' deg']);

function directionAnalysis_Callback(hObject, eventdata, handles)
getAnalysisProperties
[dir,dist]=wormLocomotion('Direction',splineFile,stageFile,frameRate,calibx,caliby,point,oldStyle,framesToAnalyze);
dir=round(dir*100)/100;
dist=round(dist*100)/100;
set(handles.movementMessages,'String',['Forward: ' num2str(dir(1)) '; ' num2str(dist(1)) ' um; Backward: ' num2str(dir(2)) '; ' num2str(dist(2)) ' um'])

function stageStyle_Callback(hObject, eventdata, handles)

function wormAmplitude_Callback(hObject, eventdata, handles)
getAnalysisProperties
[amp,alratio]=wormLocomotion('Amplitude',splineFile,stageFile,frameRate,calibx,caliby,point,oldStyle,framesToAnalyze);
meanAmp=mean(amp);
meanAmp=round(meanAmp*100)/100;
alratio=round(alratio*100)/100;
set(handles.movementMessages,'String',['Avg. Amp.: ' num2str(meanAmp) ' um; A/L Ratio: ' num2str(alratio)])


function speedAndDistance_Callback(hObject, eventdata, handles)
getAnalysisProperties
[distance,throwOut]=wormLocomotion('Distance',splineFile,stageFile,frameRate,calibx,caliby,point,oldStyle,framesToAnalyze);

%do the analysis for total distance traveled with CENTROID regardless of
%what user asks to do with distance above.
[throwOut,totalTraveled]=wormLocomotion('Distance',splineFile,stageFile,frameRate,calibx,caliby,0,oldStyle,framesToAnalyze);
speed=wormLocomotion('Speed',splineFile,stageFile,frameRate,calibx,caliby,point,oldStyle,framesToAnalyze);
totalDistance=sum(distance);
fr=get(handles.frameRate,'String'); fr=str2double(fr);
startTime=0; endTime=length(speed)/fr;
times=startTime:1/fr:endTime;
avgTimes=[];
for i=1:length(times)-1
    avg=mean([times(i) times(i+1)]);
    avgTimes=[avgTimes avg];
end
f=figure;
plot(avgTimes,speed);
title('Worm speed (absolute value)');
xlabel('Time (sec)');
ylabel('Speed (um/sec)');
meanSpeed=mean(speed);

totalDistance=round(totalDistance*100)/100;
meanSpeed=round(meanSpeed*100)/100;

set(handles.movementMessages,'String',['Tot Dist (pt-pt): ' num2str(totalDistance) ' um; Net Dist Traveled: ' num2str(totalTraveled) ' um; Avg. Speed: ' num2str(meanSpeed) ' um/sec'])


function exportWormPath_Callback(hObject, eventdata, handles)
try
    [filename pathname]=uiputfile('*.txt','Save Path Data');
    getAnalysisProperties
%     if frameRate==15
%         newFrameRate=3;
%     elseif frameRate==3
%         newFrameRate=3;
%     elseif frameRate==1
%         newFrameRate=1;
%     end
    [xData,yData]=wormLocomotion('Path',splineFile,stageFile,frameRate,calibx,caliby,point,oldStyle,framesToAnalyze);
    time=0:length(xData)-1;
    time=time/frameRate;
    data=[time' xData' yData'];
    labels=[{'%%Time'} {'%%X'} {'%%Y'}];
    saveDataMatrix(labels,data,[pathname filename]);
    set(handles.movementMessages,'String','Path Data Exported')
catch
end

function exportBendData_Callback(hObject, eventdata, handles)
try
    getAnalysisProperties
    [filename pathname]=uiputfile('*.txt','Save Bend Data');
    splinePath=get(handles.splinePath,'String');
    bendNumber=str2double(get(handles.bendNumber,'String'));
    fs=str2double(get(handles.frameRate,'String'));
    rms=ang(splinePath,bendNumber,framesToAnalyze);
    data=[];
    for bendNumber=1:11
        [freq,time,head]=fftscript(splinePath,bendNumber,fs,framesToAnalyze);
        data=[data head];
    end
    data=[time' data];
    labels=[{'%%Time'} {'%%Bend 1'} {'%%Bend 2'} {'%%Bend 3'} {'%%Bend 4'} {'%%Bend 5'} {'%%Bend 6'} {'%%Bend 7'} {'%%Bend 8'} {'%%Bend 9'} {'%%Bend 10'} {'%%Bend 11'}];
    saveDataMatrix(labels,data,[pathname filename]);
    set(handles.bendMessages,'String','Bend Data Exported')
catch
end



function exportPath_Callback(hObject, eventdata, handles)

function exportPath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function browseExport_Callback(hObject, eventdata, handles)
[filename pathname]=uiputfile('*.txt','Save Export File');
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.exportPath,'String',[pathname filename]);
end

function doMaxBend_Callback(hObject, eventdata, handles)

function saveAndAppend_Callback(hObject, eventdata, handles)
path=get(handles.exportPath,'String');

comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end


%get all of your data here...
getAnalysisProperties
bendNumber=str2double(get(handles.bendNumber,'String'));    %this one is excluded from getAnalysisProperties
%1.) Animal name and comments
slashPosition=find(splineFile==slash);
slashPosition=slashPosition(end);
animalName=splineFile(slashPosition+1:end-4);
animalName={animalName};

comments=get(handles.exportComments,'String');
if isempty(comments)
    comments='n/a';
end
comments={comments};

%2.) Length of recording
spline=load(splineFile);
if strcmp(framesToAnalyze,'all')
    numberOfRecordings=length(spline(:,1))/2;
else
    numberOfRecordings=framesToAnalyze(2)-framesToAnalyze(1)+1;
end
lengthOfRecording=numberOfRecordings/frameRate;
lengthOfRecording={num2str(lengthOfRecording)};

%3.) Sum of all bends
sumOfBends=averageSumOfBends(splineFile,framesToAnalyze);
sumOfBends={num2str(sumOfBends)};

%4.) Frequency of bend
[freq,time,head]=fftscript(splineFile,bendNumber,frameRate,framesToAnalyze);
freq={num2str(freq)};

%5.) RMS of bend
rms=ang(splineFile,bendNumber,framesToAnalyze);
rms={num2str(rms)};

%6.) Maximum bend
if get(handles.doMaxBend,'Value')
    [freq,time,head]=fftscript(splineFile,bendNumber,frameRate,framesToAnalyze);
    exc=bendCursor_gui(time,head);
    exc={num2str(exc)};
else
    exc={'n/a'};
end


%7.) Avg amplitude
[amp,alratio]=wormLocomotion('Amplitude',splineFile,stageFile,frameRate,calibx,caliby,point,oldStyle,framesToAnalyze);
meanAmp=mean(amp);
meanAmp={num2str(meanAmp)};
alratio={num2str(alratio)};

%8.) Avg speed
speed=wormLocomotion('Speed',splineFile,stageFile,frameRate,calibx,caliby,point,oldStyle,framesToAnalyze);
meanSpeed=mean(speed);
meanSpeed={num2str(meanSpeed)};

%9.) Total distance
distance=wormLocomotion('Distance',splineFile,stageFile,frameRate,calibx,caliby,point,oldStyle,framesToAnalyze);
totalDistance=sum(distance);
totalDistance={num2str(totalDistance)};

%10.) Steps forward
getAnalysisProperties
[dir,dist]=wormLocomotion('Direction',splineFile,stageFile,frameRate,calibx,caliby,point,oldStyle,framesToAnalyze);
stepsForward=dir(1);
stepsForward={num2str(stepsForward)};

%11.) Steps backward
stepsBackward=dir(2);
stepsBackward={num2str(stepsBackward)};

%12.) Distance forward
distForward=dist(1);
distForward={num2str(distForward)};

%13.) Distance backward
distBackward=dist(2);
distBackward={num2str(distBackward)};

%14.) Thrashing count
[thrashCount, thrashFreq]=thrashingFreq(splineFile,frameRate);
thrashCount={num2str(thrashCount)};
thrashFreq={num2str(thrashFreq)};

labels=[{'Animal'} {'Point'} {'Bend'} {'Comments'} {'Rec Length'} {'Avg Sum Bends'} {'Freq'} {'RMS'} {'Max Bend'} {'Avg Amp'} {'A/L Ratio'} {'Avg Spd'} {'Tot Dist'} {'Steps F'} {'Steps B'} {'Dist F'} {'Dist B'} {'Thrash Count'} {'Thrash Freq'}];
newDataLine=[animalName {num2str(point)} {num2str(bendNumber)} comments lengthOfRecording sumOfBends freq rms exc meanAmp alratio meanSpeed totalDistance stepsForward stepsBackward distForward distBackward thrashCount thrashFreq];
if ~exist(path) %if the file does not already exist, create it without using the "append" tag.
    saveDataMatrix(labels,[],path);
end

saveDataMatrix(labels,newDataLine,path,1);    %then, append the new data

disp('Data Saved')


function exportComments_Callback(hObject, eventdata, handles)

function exportComments_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function splinePath_KeyPressFcn(hObject, eventdata, handles)
comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end

if strcmp(eventdata.Key,'return')
    pause(.5)
    flashBox(handles.stagePath);
    pathname=get(handles.splinePath,'String');
    lastSlash=find(pathname==slash);
    lastSlash=lastSlash(end);
    wormName=pathname(lastSlash+1:end-16);
    stageName=[pathname(1:lastSlash) wormName slash wormName '.txt'];
    set(handles.stagePath,'String',stageName);
end

function framesToAnalyze_Callback(hObject, eventdata, handles)

function framesToAnalyze_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in thrashing.
function thrashing_Callback(hObject, eventdata, handles)
% hObject    handle to thrashing (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
getAnalysisProperties
[n,freq]=thrashingFreq(splineFile,frameRate);
freq=round(freq*10)/10;
set(handles.bendMessages,'String',['Thrashing count: ' num2str(n) ' Freq: ' num2str(freq) '/min']);
