function varargout = batchAnalyze_gui(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @batchAnalyze_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @batchAnalyze_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function batchAnalyze_gui_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;

guidata(hObject, handles);


function varargout = batchAnalyze_gui_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;


function filelist_Callback(hObject, eventdata, handles)

function filelist_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function add_Callback(hObject, eventdata, handles)
filelist=get(handles.filelist,'String');
if strcmp('Populate with the ''Add Recording'' button',filelist)
    set(handles.filelist,'String','')
end

try
    [spline,stage,frames]=fileSelectWindow;
    if isnumeric(frames)
        data=[spline ';' stage ';' num2str(frames)];
    else
        data=[spline ';' stage ';' frames];
    end
    data={data};
    olduserdata=get(handles.filelist,'UserData');
    newuserdata=[olduserdata;data];
    set(handles.filelist,'UserData',newuserdata);
    updateFilelist(handles.filelist,newuserdata);
catch
end

function remove_Callback(hObject, eventdata, handles)
recNum=inputdlg('Select Recording Number','Remove Recording');
recNum=str2double(recNum{1});
olduserdata=get(handles.filelist,'UserData');
if recNum==1
    newuserdata=[olduserdata(2:end)];
else
    newuserdata=[olduserdata(1:recNum-1);olduserdata(recNum+1:end)];
end
set(handles.filelist,'UserData',newuserdata);
updateFilelist(handles.filelist,newuserdata);

function edit_Callback(hObject, eventdata, handles)
recNum=inputdlg('Select Recording Number','Edit Recording');
recNum=str2double(recNum{1});
olduserdata=get(handles.filelist,'UserData');
try
    dataToChange=olduserdata{recNum};
    splitData=split(';',dataToChange);
    oldSpline=splitData{1};
    oldStage=splitData{2};
    oldFrames=splitData{3};
    
    
    [spline,stage,frames]=fileSelectWindow(oldSpline,oldStage,oldFrames);
    if isnumeric(frames)
        data=[spline ';' stage ';' num2str(frames)];
    else
        data=[spline ';' stage ';' frames];
    end
    data={data};
    if recNum==1
        newuserdata=[data;olduserdata(2:end)];
    else
        newuserdata=[olduserdata(1:recNum-1); data; olduserdata(recNum+1:end)];
    end
    set(handles.filelist,'UserData',newuserdata);
    updateFilelist(handles.filelist,newuserdata);
catch
end

function updateFilelist(filelist,userdata)
splines=[];
stages=[];
frames=[];
for i=1:length(userdata)
    currString=userdata(i);
    splitString=split(';',currString{1});
    try
        splines=[splines;{[num2str(i) '.) ...' splitString{1}(end-70:end)]}];
    catch
        splines=[splines;{[num2str(i) '.) ...' splitString{1}]}];
    end
    
    try
        stages=[stages;{['     ...' splitString{2}(end-70:end)]}];
    catch
        stages=[stages;{['     ...' splitString{2}]}];
    end
    
    frames=[frames;{['     ' splitString{3}]}];
end
filelistDisplay=[];
for i=1:length(userdata)
    filelistDisplay=[filelistDisplay;splines(i);stages(i);frames(i);{''}];
end
set(filelist,'String',filelistDisplay)
   


function analyzeAndExport_Callback(hObject, eventdata, handles)
analyses.sob=get(handles.sob,'Value');
analyses.freq=get(handles.freq,'Value');
analyses.rms=get(handles.rms,'Value');
analyses.mb=get(handles.mb,'Value');
analyses.amp=get(handles.amp,'Value');
analyses.spd=get(handles.spd,'Value');
analyses.dist=get(handles.dist,'Value');
analyses.dir=get(handles.dir,'Value');
analyses.thrashing=get(handles.thrashing,'Value');

options.frameRate=str2num(get(handles.framerate,'String'));
options.bendNumbers=str2num(get(handles.bendNumbers,'String'));
% if strcmp(get(handles.pointNumbers,'String'),'cog')
%     options.pointNumbers=0;
% else
options.pointNumbers=str2num(get(handles.pointNumbers,'String'));
% end
options.calibration=str2num(get(handles.calibration,'String'));
% if get(handles.trackingStyle,'Value')
%     options.trackingStyle=1;
% else
%     options.trackingStyle=0;
% end

options.trackingStyle=0;

filelist=get(handles.filelist,'UserData');
splines=[];
stages=[];
frames=[];

for i=1:length(filelist)
    currString=filelist(i);
    splitString=split(';',currString{1});
    curSpline=splitString{1};
    curStage=splitString{2};
    curFrames=splitString{3};
    if ~isempty(str2num(curFrames))
        curFrames=str2num(curFrames);
    else
        curFrames=0;
    end
    
    params(i).splineFile=curSpline;
    params(i).stageFile=curStage;
    params(i).frames=curFrames;
end

saveFile=get(handles.savePath,'String');

batchAnalyze(params,options,analyses,saveFile);
disp('Data Exported')


function browseSavePath_Callback(hObject, eventdata, handles)
[filename pathname]=uiputfile('*.txt','Save Export File');
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.savePath,'String',[pathname filename]);
end


function sob_Callback(hObject, eventdata, handles)
function freq_Callback(hObject, eventdata, handles)
function rms_Callback(hObject, eventdata, handles)
function mb_Callback(hObject, eventdata, handles)
function amp_Callback(hObject, eventdata, handles)
function spd_Callback(hObject, eventdata, handles)
function dist_Callback(hObject, eventdata, handles)
function dir_Callback(hObject, eventdata, handles)
function thrashing_Callback(hObject, eventdata, handles)


function framerate_Callback(hObject, eventdata, handles)
function framerate_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function calibration_Callback(hObject, eventdata, handles)
function calibration_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function pointNumbers_Callback(hObject, eventdata, handles)
function pointNumbers_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function bendNumbers_Callback(hObject, eventdata, handles)
function bendNumbers_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function trackingStyle_Callback(hObject, eventdata, handles)
function savePath_Callback(hObject, eventdata, handles)
function savePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function clearList_Callback(hObject, eventdata, handles)
newuserdata=[];
set(handles.filelist,'UserData',newuserdata);
updateFilelist(handles.filelist,newuserdata);


