function varargout = batchTrack_gui(varargin)

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @batchTrack_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @batchTrack_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


function batchTrack_gui_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;

guidata(hObject, handles);



function varargout = batchTrack_gui_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;

%----------------------PRIMARY ANALYSIS FUNCTION---------------------------

function start_Callback(hObject, eventdata, handles)
persistent prevX prevY

imagePath=get(handles.imagePath,'String');  %path where images are stored
filelist=get(handles.imagePath,'UserData'); %list of every image file
frameMatrix=get(handles.frame,'UserData');  %matrix of [1 2 3 4 5;6 7 ....etc]
splineData=zeros(2*length(filelist),13);    %splineData is what will eventually be exported.
splineDataOrig=zeros(2*length(filelist),13);
stageMovement=get(handles.stagePath,'UserData');    %x-y coordinates of stage movement each second
% clow=str2double(get(handles.clow,'String'));
% chigh=str2double(get(handles.chigh,'String'));
clow=0;chigh=1;
calibx=str2double(get(handles.calibx,'String'));
caliby=str2double(get(handles.caliby,'String'));
frameRate=str2double(get(handles.frameRate,'String'));
threshold=str2double(get(handles.threshold,'String'));
threshold=[threshold .9*threshold 1.1*threshold .8*threshold 1.2*threshold];    %a list of thresholds to scan through

%ANALYSIS LOOP
%Please check the analysisLoop.m file for specifics; this is the most
%important part of the program!!
%
analysisLoop
%
%
%

set(handles.text16,'UserData',splineDataOrig);  %this is the raw data expressed in pixels
set(handles.splinePath,'UserData',splineData); %this is the stage-compensated and calibrated data expressed in micrometers
set(handles.crossA,'UserData',crossdata); %this is the crossed version of the raw data, only relevant for omega bends

disp('Done Analyzing Frames')
topRow=str2double(get(handles.topRow,'String'));

ventralDir=get(handles.ventralMessage,'UserData');

displaySplines

for win=['A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J']
    eval(['set(handles.swap' win ',''Enable'',''on'')']);
    eval(['set(handles.manual' win ',''Enable'',''on'')']);
end

%--------------------END PRIMARY ANALYSIS FUNCTION-------------------------

% function [xcl,ycl]=compensateForStage(xcl,ycl,frameNumber,stageMovement,frameRate,calibx,caliby)
% %xcl, ycl are row vectors;
% rowNum=floor((frameNumber-1)/frameRate)+1;    %rowNum tells you the most recent stage movement row number.
% xStageMovement=stageMovement(:,1);
% yStageMovement=stageMovement(:,2);
% xMove=sum(xStageMovement(1:rowNum))/calibx; %this is the movement of the stage in PIXELS not MICRONS!
% yMove=sum(yStageMovement(1:rowNum))/caliby;
% xcl=xcl+xMove;  %EVERYTHING SHOULD BE IN PIXELS
% ycl=ycl+yMove;

function [xcl,ycl]=compensateForStage(xcl,ycl,frameNumber,stageMovement,frameRate,calibx,caliby)
%xcl, ycl are row vectors;

rowNum=floor((frameNumber+1)/frameRate)+1;
xStageMovement=stageMovement(:,1);
yStageMovement=stageMovement(:,2);
xMove=sum(xStageMovement(1:rowNum))/calibx; %calibration is done here in pixels!
yMove=sum(yStageMovement(1:rowNum))/caliby;
xcl=xcl+xMove;
ycl=ycl+yMove;



function load_Callback(hObject, eventdata, handles)
comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end

stagePath=get(handles.stagePath,'String');
imagePath=get(handles.imagePath,'String');
set(handles.text16,'UserData',[]);
set(handles.splinePath,'UserData',[]);
%load the data file
stageMovement=load(stagePath);
set(handles.stagePath,'UserData',stageMovement);

%set the crossdata to empty, in case it was retained from a previous set
set(handles.crossA,'UserData',[]);

%load the spline filelist
fixNumbers(imagePath);
filelist=listBmpsInFolder(imagePath);
set(handles.imagePath,'UserData',filelist);
frameNum=length(filelist);
m=ceil(frameNum/5);
frameMatrix=zeros(5,m);
frameMatrix(1:frameNum)=1:frameNum;
frameMatrix=frameMatrix';
set(handles.frame,'UserData',frameMatrix);
updateFrames(handles,1);
set(handles.pageUp,'Enable','off')
set(handles.pageDown,'Enable','on')
set(handles.topRow,'String','1')

for win=['A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J']
    eval(['set(handles.swap' win ',''Enable'',''off'')']);
    eval(['set(handles.manual' win ',''Enable'',''off'')']);
end

ventralDir=zeros(1,length(filelist)); %0 = none
for i=1:length(filelist)
    currFile=filelist{i};
    lastSlash=find(currFile==slash); lastSlash=lastSlash(end);
    currFile=currFile(lastSlash+1:end);
    if strcmp(currFile(1:2),'R_') %1 = right (starboard)
        ventralDir(i)=1;
    elseif strcmp(currFile(1:2),'L_') %2 = left (port)
        ventralDir(i)=2;
    else
        ventralDir(i)=0;
    end
end
set(handles.ventralMessage,'UserData',ventralDir); %store the ventral direction for plotting

function pageUp_Callback(hObject, eventdata, handles)
frameMatrix=get(handles.frame,'UserData');
l=length(frameMatrix(:,1));
topRow=str2double(get(handles.topRow,'String'));
topRow=topRow-1;
set(handles.topRow,'String',num2str(topRow));
if topRow==l-2
    set(handles.pageDown,'Enable','on')
end
if topRow==1
    set(handles.pageUp,'Enable','off')
end
updateFrames(handles,topRow);


function pageDown_Callback(hObject, eventdata, handles)
frameMatrix=get(handles.frame,'UserData');
l=length(frameMatrix(:,1));
topRow=str2double(get(handles.topRow,'String'));
topRow=topRow+1;
set(handles.topRow,'String',num2str(topRow));
if topRow==l-1
    set(handles.pageDown,'Enable','off')
end
if topRow==2
    set(handles.pageUp,'Enable','on')
end
updateFrames(handles,topRow);

function updateFrames(handles,topRow)
imagePath=get(handles.imagePath,'String');
filelist=get(handles.imagePath,'UserData');
frameMatrix=get(handles.frame,'UserData');
framesToDisplay=frameMatrix(topRow:topRow+1,:);


axes(handles.winA)
showFrame(filelist,framesToDisplay(1,1));
set(handles.frameA,'String',num2str(framesToDisplay(1,1)));
axes(handles.winB)
showFrame(filelist,framesToDisplay(1,2));
set(handles.frameB,'String',num2str(framesToDisplay(1,2)));
axes(handles.winC)
showFrame(filelist,framesToDisplay(1,3));
set(handles.frameC,'String',num2str(framesToDisplay(1,3)));
axes(handles.winD)
showFrame(filelist,framesToDisplay(1,4));
set(handles.frameD,'String',num2str(framesToDisplay(1,4)));
axes(handles.winE)
showFrame(filelist,framesToDisplay(1,5));
set(handles.frameE,'String',num2str(framesToDisplay(1,5)));
axes(handles.winF)
showFrame(filelist,framesToDisplay(2,1));
set(handles.frameF,'String',num2str(framesToDisplay(2,1)));
axes(handles.winG)
showFrame(filelist,framesToDisplay(2,2));
set(handles.frameG,'String',num2str(framesToDisplay(2,2)));
axes(handles.winH)
showFrame(filelist,framesToDisplay(2,3));
set(handles.frameH,'String',num2str(framesToDisplay(2,3)));
axes(handles.winI)
showFrame(filelist,framesToDisplay(2,4));
set(handles.frameI,'String',num2str(framesToDisplay(2,4)));
axes(handles.winJ)
showFrame(filelist,framesToDisplay(2,5));
set(handles.frameJ,'String',num2str(framesToDisplay(2,5)));

ventralDir=get(handles.ventralMessage,'UserData'); %retrieve the ventral direction for plotting

splineDataOrig=get(handles.text16,'UserData');
if ~isempty(splineDataOrig)
    displaySplines
end

function showFrame(filelist,frameNum)
if frameNum~=0
    img=imread(filelist{frameNum});
    imshow(img)
else
    c=get(gca,'children');
    delete(c)
    set(gca,'Color',[.831 .816 .784]);
end

function filelist=listBmpsInFolder(path)
%this function will make a cell array of the Bmp files in a folder.
comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end

list=dir([path slash '*.bmp']);
filelist=[];
for i=1:length(list)
    filelist=[filelist; {[path slash list(i).name]}];
end


function save_Callback(hObject, eventdata, handles)
splineData=get(handles.splinePath,'UserData');
ventralData=get(handles.ventralMessage,'UserData');
crossdata=get(handles.crossA,'UserData');

if length(ventralData(:,1))==1
    ventralData=ventralData';
end

doubledVentralData=zeros(length(ventralData)*2,1);
ind=1;
for i=1:2:length(doubledVentralData)-1
    doubledVentralData(i:i+1)=ventralData(ind);
    ind=ind+1;
end

data=[doubledVentralData splineData];
savePath=get(handles.splinePath,'String');
labels=[{'%%Ventral'} {'%%Head'} {'%%Node 2'} {'%%3'} {'%%4'} {'%%5'} {'%%6'} {'%%7'} {'%%8'} {'%%9'} {'%%10'} {'%%11'} {'%%12'} {'%%Tail'}];
saveDataMatrix(labels,data,savePath);

splineDataOrig=get(handles.text16,'UserData');
data_orig=[doubledVentralData splineDataOrig crossdata];
savePath=[savePath(1:end-4) '_orig.txt'];
labels=[{'%%Ventral'} {'%%Head'} {'%%Node 2'} {'%%3'} {'%%4'} {'%%5'} {'%%6'} {'%%7'} {'%%8'} {'%%9'} {'%%10'} {'%%11'} {'%%12'} {'%%Tail'} {'%%Cross1'} {'%%C 2'} {'%%C 3'} {'%%C 4'} {'%%C 5'} {'%%C 6'} {'%%C 7'} {'%%C 8'} {'%%C 9'} {'%%C 10'} {'%%C 11'} {'%%C12'} {'%%C 13'}];
saveDataMatrix(labels,data_orig,savePath);
disp('Changes have been saved');

function swapA_Callback(hObject, eventdata, handles)
f='A';
swapScript


function manualA_Callback(hObject, eventdata, handles)
f='A';
manualScript

function swapB_Callback(hObject, eventdata, handles)
f='B';
swapScript

function manualB_Callback(hObject, eventdata, handles)
f='B';
manualScript

function swapC_Callback(hObject, eventdata, handles)
f='C';
swapScript

function manualC_Callback(hObject, eventdata, handles)
f='C';
manualScript

function swapD_Callback(hObject, eventdata, handles)
f='D';
swapScript

function manualD_Callback(hObject, eventdata, handles)
f='D';
manualScript

function swapE_Callback(hObject, eventdata, handles)
f='E';
swapScript

function manualE_Callback(hObject, eventdata, handles)
f='E';
manualScript

function swapF_Callback(hObject, eventdata, handles)
f='F';
swapScript

function manualF_Callback(hObject, eventdata, handles)
f='F';
manualScript

function swapG_Callback(hObject, eventdata, handles)
f='G';
swapScript

function manualG_Callback(hObject, eventdata, handles)
f='G';
manualScript

function swapH_Callback(hObject, eventdata, handles)
f='H';
swapScript

function manualH_Callback(hObject, eventdata, handles)
f='H';
manualScript

function swapI_Callback(hObject, eventdata, handles)
f='I';
swapScript

function manualI_Callback(hObject, eventdata, handles)
f='I';
manualScript

function swapJ_Callback(hObject, eventdata, handles)
f='J';
swapScript

function manualJ_Callback(hObject, eventdata, handles)
f='J';
manualScript

function browseStage_Callback(hObject, eventdata, handles)
persistent lastStagePath
comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end

if isempty(lastStagePath)
    imagePath=get(handles.imagePath,'String');
    [filename pathname]=uigetfile('*.txt','Open Stage File',imagePath);
else
    [filename pathname]=uigetfile('*.txt','Open Stage File',lastStagePath);
end
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.stagePath,'String',[pathname filename]);
    lastStagePath=pathname;
end

function browseImage_Callback(hObject, eventdata, handles)
persistent lastImagePath
if isempty(lastImagePath)
    pathname=uigetdir();
else
    pathname=uigetdir(lastImagePath);
end

comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end



if ~isnumeric(pathname)
    set(handles.imagePath,'String',pathname)
    lastSlash=find(pathname==slash);
    lastSlash=lastSlash(end);
    stageName=[pathname slash pathname(lastSlash+1:end) '.txt'];
    set(handles.stagePath,'String',stageName);
    splineName=[pathname '_spline.txt'];
    set(handles.splinePath,'String',splineName)
    
    input_splineData_path=[pathname slash 'batchProduced_splineData.txt'];
    input_splineData_orig_path=[pathname slash 'batchProduced_splineData_orig.txt'];
    set(handles.input_splinePath,'String',input_splineData_path);
    set(handles.input_splinePath_orig,'String',input_splineData_orig_path);
    lastImagePath=pathname;
end

function imagePath_Callback(hObject, eventdata, handles)

function imagePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function stagePath_Callback(hObject, eventdata, handles)

function stagePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function input_splinePath_Callback(hObject, eventdata, handles)

function input_splinePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function splinePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function browseInputSpline_Callback(hObject, eventdata, handles)
persistent lastInputSpline
if isempty(lastInputSpline)
    [filename pathname]=uigetfile('*.txt','Open Spline File');
else
    [filename pathname]=uigetfile('*.txt','Open Spline File',lastInputSpline);
end
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.input_splinePath,'String',[pathname filename]);
    lastInputSpline=pathname;
end

function threshold_Callback(hObject, eventdata, handles)

function threshold_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function frameRate_Callback(hObject, eventdata, handles)

function frameRate_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function calibx_Callback(hObject, eventdata, handles)

function calibx_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function caliby_Callback(hObject, eventdata, handles)

function caliby_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on imagePath and none of its controls.
function imagePath_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to imagePath (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end


if strcmp(eventdata.Key,'return')
    pause(.5)
    flashBox(handles.stagePath,handles.input_splinePath,handles.input_splinePath_orig,handles.splinePath);
    pathname=get(handles.imagePath,'String');
    lastSlash=find(pathname==slash);
    lastSlash=lastSlash(end);
    stageName=[pathname slash pathname(lastSlash+1:end) '.txt'];
    set(handles.stagePath,'String',stageName);
    splineName=[pathname '_spline.txt'];
    set(handles.splinePath,'String',splineName)
    
    input_splineData_path=[pathname slash 'batchProduced_splineData.txt'];
    input_splineData_orig_path=[pathname slash 'batchProduced_splineData_orig.txt'];
    set(handles.input_splinePath,'String',input_splineData_path);
    set(handles.input_splinePath_orig,'String',input_splineData_orig_path);
end


% --- Executes on button press in loadSpline.
function loadSpline_Callback(hObject, eventdata, handles)
% hObject    handle to loadSpline (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

splinePath=get(handles.input_splinePath,'String');
splinePath_orig=get(handles.input_splinePath_orig,'String');

splineData=load(splinePath);
splineData_orig=load(splinePath_orig);

if length(splineData_orig(1,:))==14  %if there has been ventral data saved into the spline file
    ventralData=splineData_orig(1:2:end,1);
    splineData=splineData(:,2:end);
    splineData_orig=splineData_orig(:,2:end);
    
end
crossdata=zeros(length(splineData(:,1)),length(splineData(1,:)));

if length(splineData_orig(1,:))==27 %if there is ventral data as well as crossed data stored in the spline file
    ventralData=splineData_orig(1:2:end,1);
    crossdata=splineData_orig(:,15:end);
    splineData_orig=splineData_orig(:,2:14);
    splineData=splineData(:,2:end);
    
end

if length(splineData_orig(1,:))==26 %if there is no ventral data, but there is crossed data
    ventralData=zeros(length(splineData(1:2:end,1)),1);
    crossdata=splineData_orig(:,14:end);
    splineData_orig=splineData_orig(:,1:13);
    splineData=splineData(:,1:end);
    
end
ventralData=ventralData';

set(handles.splinePath,'UserData',splineData);
set(handles.text16,'UserData',splineData_orig);
set(handles.crossA,'UserData',crossdata);
set(handles.ventralMessage,'UserData',ventralData);

disp('Loaded previously produced spline data');
updateFrames(handles,1);

for win=['A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J']
    eval(['set(handles.swap' win ',''Enable'',''on'')']);
    eval(['set(handles.manual' win ',''Enable'',''on'')']);
end

function input_splinePath_orig_Callback(hObject, eventdata, handles)
% hObject    handle to input_splinePath_orig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of input_splinePath_orig as text
%        str2double(get(hObject,'String')) returns contents of input_splinePath_orig as a double


% --- Executes during object creation, after setting all properties.
function input_splinePath_orig_CreateFcn(hObject, eventdata, handles)
% hObject    handle to input_splinePath_orig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in browseInputSpline_orig.
function browseInputSpline_orig_Callback(hObject, eventdata, handles)
% hObject    handle to browseInputSpline_orig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
persistent lastInputSplineOrig
if isempty(lastInputSplineOrig)
    [filename pathname]=uigetfile('*.txt','Open Spline (Orig) File');
else
    [filename pathname]=uigetfile('*.txt','Open Spline (Orig) File',lastInputSplineOrig);
end
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.input_splinePath_orig,'String',[pathname filename]);
    lastInputSplineOrig=pathname;
end


% --- Executes on button press in browseSpline.
function browseSpline_Callback(hObject, eventdata, handles)
% hObject    handle to browseSpline (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename pathname]=uiputfile('*.txt','Open Stage File');
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.splinePath,'String',[pathname filename]);
end






function crossF_Callback(hObject, eventdata, handles)
f='F';
crossScript

function crossG_Callback(hObject, eventdata, handles)
f='G';
crossScript

function crossH_Callback(hObject, eventdata, handles)
f='H';
crossScript

function crossI_Callback(hObject, eventdata, handles)
f='I';
crossScript;

function crossJ_Callback(hObject, eventdata, handles)
f='J';
crossScript

function crossE_Callback(hObject, eventdata, handles)
f='E';
crossScript

function crossD_Callback(hObject, eventdata, handles)
f='D';
crossScript

function crossC_Callback(hObject, eventdata, handles)
f='C';
crossScript

function crossB_Callback(hObject, eventdata, handles)
f='B';
crossScript

function crossA_Callback(hObject, eventdata, handles)
f='A';
crossScript
