function varargout = calibration_gui(varargin)
% CALIBRATION_GUI M-file for calibration_gui.fig
%      CALIBRATION_GUI, by itself, creates a new CALIBRATION_GUI or raises the existing
%      singleton*.
%
%      H = CALIBRATION_GUI returns the handle to a new CALIBRATION_GUI or the handle to
%      the existing singleton*.
%
%      CALIBRATION_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CALIBRATION_GUI.M with the given input arguments.
%
%      CALIBRATION_GUI('Property','Value',...) creates a new CALIBRATION_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before calibration_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to calibration_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help calibration_gui

% Last Modified by GUIDE v2.5 29-Jun-2010 17:41:18

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @calibration_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @calibration_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before calibration_gui is made visible.
function calibration_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to calibration_gui (see VARARGIN)

% Choose default command line output for calibration_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes calibration_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = calibration_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function done_Callback(hObject, eventdata, handles)
x=str2double(get(handles.x,'String'));
y=str2double(get(handles.y,'String'));
currData=get(handles.done,'UserData');
xLength=abs(currData(2,1)-currData(1,1));
yLength=abs(currData(2,2)-currData(1,2));
cx=x/xLength;   %this is how many mm per pixel.
cy=y/yLength;

if isinf(cx) || isnan(cx)
    cx=[];
end

if isinf(cy) || isnan(cy)
    cy=[];
end

calibstring=['[' num2str(cx) ' ' num2str(cy) ']'];
set(handles.results,'String',calibstring);
set(handles.messages,'String','Done; Click "Disconnect Camera" to finish')

function y_Callback(hObject, eventdata, handles)

function y_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function x_Callback(hObject, eventdata, handles)

function x_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function connectCamera_Callback(hObject, eventdata, handles)
vid = videoinput('dcam', 1, 'Y8_640x480');
% vid = videoinput('winvideo', 1, 'RGB24_640x480');
src=getselectedsource(vid);
triggerconfig(vid,'manual');
set(vid,'LoggingMode','memory')
set(src,'FrameRate','15')
set(vid,'TimeOut',30)
set(handles.connectCamera,'UserData',vid);
brightness=round(str2double(get(handles.brightness,'String')));
exposure=round(str2double(get(handles.exposure,'String')));
set(src,'Brightness',brightness);
set(src,'AutoExposure',exposure);
set(src,'FrameRate','15');
axes(handles.win);
hImage=image;
preview(vid,hImage);
hold on
set(hImage,'buttondownfcn',{@click})
f=1;
set(handles.messages,'String','Click two points along the calibration slide.')
while f
    currData=get(hImage,'UserData');
    if ~isempty(currData)
        if length(currData(:,1))==2
            f=0;
        end
    end
    pause(.1)
end
line([currData(1,1) currData(2,1)],[currData(1,2) currData(2,2)],'Color','r','LineWidth',2,'Marker','.','MarkerSize',6)
hold off
set(handles.done,'UserData',currData);
set(handles.messages,'String','Enter Calibration Values and Press ''Done''')

function brightness_Callback(hObject, eventdata, handles)

function brightness_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function exposure_Callback(hObject, eventdata, handles)

function exposure_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function disconnectCamera_Callback(hObject, eventdata, handles)
vid=get(handles.connectCamera,'UserData');
stop(vid)
stoppreview(vid)
clear vid
set(handles.messages,'String','Camera Disconnected')


function apply_Callback(hObject, eventdata, handles)
vid=get(handles.connectCamera,'UserData');
src=getselectedsource(vid);
brightness=round(str2double(get(handles.brightness,'String')));
exposure=round(str2double(get(handles.exposure,'String')));
set(src,'Brightness',brightness);
set(src,'AutoExposure',exposure);

function click(gcbo,hObject)
data=get(gcbo,'UserData');
p=get(gca,'CurrentPoint');
p=p(1,1:2);
plot(p(1),p(2),'.','MarkerSize',12,'Color','r');
data=[data;p];
set(gcbo,'UserData',data); %store some userdata in the image temporarily
disp(p)
