function varargout = camera_gui(varargin)
% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @camera_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @camera_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

function camera_gui_OpeningFcn(hObject, eventdata, handles, varargin)
global xDisplacement yDisplacement
handles.output = hObject;
guidata(hObject, handles);

function varargout = camera_gui_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;


function connectCamera_Callback(hObject, eventdata, handles)
vid = videoinput('dcam', 1, 'Y8_640x480');
%Below is custom code for testing on webcams
% vid = videoinput('macvideo', 1, 'YCbCr422_1280x720');
% vid = videoinput('winvideo', 1, 'RGB24_640x480');
% vid = videoinput('winvideo', 2, 'YUY2_640x480');
% vid.ReturnedColorspace = 'grayscale';
% vid.ROIPosition = [0 0 640 480];

src=getselectedsource(vid);
triggerconfig(vid,'manual');
set(vid,'LoggingMode','memory')
set(src,'FrameRate','15')
set(vid,'TimeOut',30)
set(handles.connectCamera,'UserData',vid);
brightness=round(str2double(get(handles.brightness,'String')));
exposure=round(str2double(get(handles.exposure,'String')));
framerate=get(handles.fps,'Value');
switch framerate
    case 1
        FrameGrabInterval=1;
        FramesPerTrigger=15;
    case 2
        FrameGrabInterval=3;
        FramesPerTrigger=5;
    case 3
        FrameGrabInterval=5;
        FramesPerTrigger=3;
    case 4
        FrameGrabInterval=15;
        FramesPerTrigger=1;
end
set(src,'Brightness',brightness);
set(src,'AutoExposure',exposure);
set(src,'FrameRate','15');
set(vid,'FrameGrabInterval',FrameGrabInterval)
set(vid,'FramesPerTrigger',FramesPerTrigger)
axes(handles.win);
hImage=image;
preview(vid,hImage);
set(handles.cameraStatus,'ForegroundColor','g')

function connectStage_Callback(hObject, eventdata, handles)
try
    comPort=get(handles.comPort,'String');
    comPort=['COM' comPort];
    stage=serial(comPort,'baudrate',9600,'terminator','CR');
    stage.ReadAsyncMode='manual';    %create the serial port
    fopen(stage);
    set(handles.connectStage,'UserData',stage)
    set(handles.messages,'String','Connecting')
    pause(3)    %pause for 3 seconds because the stage needs a second to start up
    fprintf(stage,'$'); out=fscanf(stage); %test the stage output
    if str2double(out)==0
        set(handles.messages,'String','Stage Connected')
        set(handles.stageStatus,'ForegroundColor','g')
        fprintf(stage,'SMS,100');
        fprintf(stage,'SAS,100');
    else
        msgbox('Please Check Connections--Stage Not Detected.  See Matlab Command Window for Debug.');
        stage
        disp('Stage output mismatch.  Try again.')
    end
catch
    msgbox('Please Check Connections--Stage Not Detected.  See Matlab Command Window for Debug.');
    stage
    disp('Crash during connection phase detected.')
end


%         set(handles.messages,'String','Stage Connected')
%         set(handles.stageStatus,'ForegroundColor','g')
    
function start_Callback(hObject, eventdata, handles)
global xDisplacement yDisplacement mydaq %I don't think these displacements need to be global anymore.




comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end
set(handles.forceStop,'UserData',[])
calibx=str2double(get(handles.calibx,'String'));
caliby=str2double(get(handles.caliby,'String'));
trackingThreshold=str2double(get(handles.trackingThreshold,'String'));
vid=get(handles.connectCamera,'UserData');
stage=get(handles.connectStage,'UserData');
xDisplacement=0; yDisplacement=0;
% setPos(handles,[xDisplacement yDisplacement])
rectime=get(handles.rectime,'String'); rectime=str2double(rectime);
dx=zeros(rectime,1);
dy=zeros(rectime,1);
% dx(1)=0;dy(1)=0;
stoppreview(vid)
set(vid,'TriggerRepeat',rectime)
set(handles.messages,'String','Tracking and Acquiring')
axes(handles.win);
tifPath=get(handles.tifPath,'String');
mkdir(tifPath);

useSequence=get(handles.useSequence,'Value');

if ~isempty(mydaq) && useSequence 
    ch1=get(handles.ch1,'Value');
    ch2=get(handles.ch2,'Value');
    ch3=get(handles.ch3,'Value');
    rpt1=str2num(get(handles.repeat1,'String'));
    rpt2=str2num(get(handles.repeat2,'String'));
    rpt3=str2num(get(handles.repeat3,'String'));

    if ch1
        seq1=get(handles.sequence1,'String');
        seq1=processSequence(seq1,rpt1,rectime);
    else
        seq1=[];
    end
    while length(seq1)<rectime
        seq1=strcat(seq1,'0');
    end
    if ch2
        seq2=get(handles.sequence2,'String');
        seq2=processSequence(seq2,rpt2,rectime);
    else
        seq2=[];
    end
    while length(seq2)<rectime
        seq2=strcat(seq2,'0');
    end
    if ch3
        seq3=get(handles.sequence3,'String');
        seq3=processSequence(seq3,rpt3,rectime);
    else
        seq3=[];
    end
    while length(seq3)<rectime
        seq3=strcat(seq3,'0');
    end
    seqs=[{seq1};{seq2};{seq3}]; 
else
    seqs=[];
end

start(vid)
pause(4) %Our camera requires this time in order to adjust auto-exposure and other parameters

% vd=get(handles.pickvd,'Value');

for i=1:rectime
    
    if ~isempty(seqs)
        state1=str2double(seqs{1}(i));
        state2=str2double(seqs{2}(i));
        state3=str2double(seqs{3}(i));
        outputString=[state1 state2 state3];
        mydaq.outputSingleScan(outputString);
    end
    
    trigger(vid);
    wait(vid,30,'logging')
    [f,t]=getdata(vid);
    eval(['f' num2str(i) '=f;']);
    eval(['t' num2str(i) '=t;']);
    lastframe=f(:,:,1,end);
    imshow(lastframe)
%     
%     if i==1 && vd
%         pickVD(lastframe,tifPath);
%         axes(handles.win);
%     end
%     
    
    lastframe(lastframe>trackingThreshold)=255;    %threshold default is set to 80 for a simple contrast enhancement
    lastframe(lastframe<=trackingThreshold)=0;
    [cogX,cogY]=cog(lastframe);
    disp([cogX cogY]);
    [xDisplacement,yDisplacement]=centerWorm(stage,cogX,cogY,calibx,caliby);    %we are going to center the image based on um, not pixels
    dx(i)=xDisplacement;
    dy(i)=yDisplacement;
    stop=checkStopButton(handles.forceStop);
    if stop        
        set(handles.messages,'String','Cancelling... Please Wait')
        pause(2)
        disconnectCamera_Callback(hObject, eventdata, handles);
        set(handles.messages,'String','Cancelled.')
        return
    end
end
% stop(vid)
set(handles.messages,'String','Saving to bmps')
pause(.5)
m=1;

vd=[0 0 0];
vd(1)=get(handles.ventralRight,'Value');
vd(2)=get(handles.ventralLeft,'Value');
vd(3)=get(handles.noVentral,'Value');
if vd(1)
    ventralDir='R_';
elseif vd(2)
    ventralDir='L_';
elseif vd(3)
    ventralDir='';
end

for i=1:rectime %from 1 to recording time
    for j=1:length(f1(1,1,1,:)) %from 1 to the total frames in each trigger
        if m<10
            number=['0000' num2str(m)];
        elseif m>=10 && m<100
            number=['000' num2str(m)];
        elseif m>=100 && m<1000
            number=['00' num2str(m)];
        elseif m>=1000 && m<10000
            number=['0' num2str(m)];
        elseif m>=10000
            number=[num2str(m)];
        end
        name=[tifPath slash ventralDir 'img' number '.bmp'];
        eval(['currImg=f' num2str(i) '(:,:,:,j);']);
        imwrite(currImg,name,'bmp');
        m=m+1;
    end
end

set(handles.messages,'String','Saving coordinate data')

labels=[{'%%delta-x'} {'%%delta-y'}];
savePath=get(handles.exportPath,'String');
dx(isnan(dx))=0;  dy(isnan(dy))=0;
dx=num2cell(dx); dy=num2cell(-dy);  
%dy should be flipped, since the convention for dy is different in the 
%"normal" coordinate system compared to the image system
data=[dx dy];
data=[{0} {0};data];
saveDataMatrix(labels,data,savePath);
set(handles.messages,'String','Saving Complete')

function apply_Callback(hObject, eventdata, handles)
vid=get(handles.connectCamera,'UserData');
src=getselectedsource(vid);
brightness=round(str2double(get(handles.brightness,'String')));
exposure=round(str2double(get(handles.exposure,'String')));
framerate=get(handles.fps,'Value');
switch framerate
    case 1
        FrameGrabInterval=1;
        FramesPerTrigger=15;
    case 2
        FrameGrabInterval=3;
        FramesPerTrigger=5;
    case 3
        FrameGrabInterval=5;
        FramesPerTrigger=3;
    case 4
        FrameGrabInterval=15;
        FramesPerTrigger=1;
end
set(src,'Brightness',brightness);
set(src,'AutoExposure',exposure);
set(src,'FrameRate','15');
set(vid,'FrameGrabInterval',FrameGrabInterval)
set(vid,'FramesPerTrigger',FramesPerTrigger)    

function fps_Callback(hObject, eventdata, handles)

function fps_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function rectime_Callback(hObject, eventdata, handles)

function rectime_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function adjust_Callback(hObject, eventdata, handles)
showFrame(1,handles);

function tifPath_Callback(hObject, eventdata, handles)

function tifPath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function browse_Callback(hObject, eventdata, handles)
comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end
persistent lastPathname

if ~isnumeric(lastPathname)
    pathname=uigetdir(lastPathname);
else
    pathname=uigetdir();
end
if ~isnumeric(pathname)
    set(handles.tifPath,'String',pathname)
    lastSlash=find(pathname==slash);
    lastSlash=lastSlash(end);
    stageName=[pathname slash pathname(lastSlash+1:end) '.txt'];
    set(handles.exportPath,'String',stageName);
    lastPathname=pathname;
end
% lastPathname

function caliby_Callback(hObject, eventdata, handles)

function caliby_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function calibx_Callback(hObject, eventdata, handles)

function calibx_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function disconnectCamera_Callback(hObject, eventdata, handles)
vid=get(handles.connectCamera,'UserData');
stop(vid)
stoppreview(vid)
set(handles.cameraStatus,'ForegroundColor','r')
set(handles.messages,'String','Camera Disconnected')
clear vid

function disconnectStage_Callback(hObject, eventdata, handles)
stage=get(handles.connectStage,'UserData');
fclose(stage)
status=stage.Status;
if strcmp(status,'closed')
    set(handles.messages,'String','Stage Disconnected')
    set(handles.stageStatus,'ForegroundColor','r')
else
    msgbox('Could Not Disconnect.  See Matlab Command Window for Debug.')
    stage
end

function exportPath_Callback(hObject, eventdata, handles)


function exportPath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function exportBrowse_Callback(hObject, eventdata, handles)
persistent stageExportPath
[filename pathname]=uiputfile('*.txt','Save Export File',stageExportPath);
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.exportPath,'String',[pathname filename]);
    stageExportPath=pathname;
end

%---------------------------Helper Functions-------------------------------

function filelist=listTifsInFolder(path)
%this function will make a cell array of the Tif files in a folder.
comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end
list=dir([path slash '*.Tif']);
filelist=[];
for i=1:length(list)
    filelist=[filelist; {[path slash list(i).name]}];
end

function showFrame(number,handles)
filelist=get(handles.mainpanel,'UserData');

clow=get(handles.clow,'String');    clow=str2double(clow);
chigh=get(handles.chigh,'String');  chigh=str2double(chigh);

imgContrast=prepImage(filelist{number},clow,chigh);
axes(handles.win)
imshow(imgContrast);
set(handles.win,'UserData',imgContrast);

function setPos(handles,position)
set(handles.X,'String',num2str(position(1)));
set(handles.Y,'String',num2str(position(2)));
set(handles.X,'UserData',position(1));
set(handles.Y,'UserData',position(2));

function [x,y]=getPos(handles)
x=get(handles.X,'UserData');
y=get(handles.Y,'UserData');

function [x,y]=cog(img)
img=double(img);
img=255-img;
img=img/max(max(img));
s=sum(sum(img));
xt=zeros(1,length(img(1,:)));
for i=1:length(img(1,:))
    xt(i)=sum(img(:,i))*i;
end
x=sum(xt)/s;
yt=zeros(1,length(img(:,1)));
for i=1:length(img(:,1))
    yt(i)=sum(img(i,:))*i;
end
y=sum(yt)/s;

%-----------------------Stage driver functions-----------------------------
function [xDisplacement,yDisplacement]=centerWorm(stage,cogX,cogY,calibx,caliby)
centerOfImageX=320; centerOfImageY=240; %since resolution is 640x480
xMove=calibx*(centerOfImageX-cogX);  %if <0, move left; if >0, move right.  xMove is in micrometers, not pixels
yMove=caliby*(centerOfImageY-cogY);  %if <0, move down; if >0, move up.  yMove is in um.
disp(['Moved ' num2str(xMove) ',' num2str(yMove)]);
xDisplacement=-xMove; yDisplacement=-yMove;  
%the signs are reversed to reflect movement of the coordinate system, not camera.
moveRelative(stage,xMove,yMove);

function moveLeft(s,n)
cmd=['L,' num2str(n)];
fprintf(s,cmd);

function moveRight(s,n)
cmd=['R,' num2str(n)];
fprintf(s,cmd);

function moveUp(s,n)
cmd=['F,' num2str(n)];
fprintf(s,cmd);

function moveDown(s,n)
cmd=['B,' num2str(n)];
fprintf(s,cmd);

function moveRelative(s,x,y)
cmd=['GR,' num2str(x) ',' num2str(y)];
fprintf(s,cmd);
%----------------------End Stage Driver Functions--------------------------

%----------------Camera Adjustment Functions-------------------------------
function up_Callback(hObject, eventdata, handles)
stage=get(handles.connectStage,'UserData');
fprintf(stage,'F,10');

function left_Callback(hObject, eventdata, handles)
stage=get(handles.connectStage,'UserData');
fprintf(stage,'L,10');

function right_Callback(hObject, eventdata, handles)
stage=get(handles.connectStage,'UserData');
fprintf(stage,'R,10');

function down_Callback(hObject, eventdata, handles)
stage=get(handles.connectStage,'UserData');
fprintf(stage,'B,10');

function bigup_Callback(hObject, eventdata, handles)
stage=get(handles.connectStage,'UserData');
fprintf(stage,'F,100');

function bigdown_Callback(hObject, eventdata, handles)
stage=get(handles.connectStage,'UserData');
fprintf(stage,'B,100');

function bigright_Callback(hObject, eventdata, handles)
stage=get(handles.connectStage,'UserData');
fprintf(stage,'R,100');

function bigleft_Callback(hObject, eventdata, handles)
stage=get(handles.connectStage,'UserData');
fprintf(stage,'L,100');

function centerStage_Callback(hObject, eventdata, handles)
stage=get(handles.connectStage,'UserData');
fprintf(stage,'G,0,0');

%------------End Camera Adjustment Functions-------------------------------



function brightness_Callback(hObject, eventdata, handles)

function brightness_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function exposure_Callback(hObject, eventdata, handles)

function exposure_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function tifPath_KeyPressFcn(hObject, eventdata, handles)
comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end
if strcmp(eventdata.Key,'return')
    pause(.5)
    flashBox(handles.exportPath)
    pathname=get(handles.tifPath,'String');
    lastSlash=find(pathname==slash);
    lastSlash=lastSlash(end);
    stageName=[pathname slash pathname(lastSlash+1:end) '.txt'];
    set(handles.exportPath,'String',stageName);
end


function forceStop_Callback(hObject, eventdata, handles)
set(handles.forceStop,'UserData',1);

function stop=checkStopButton(stopButton)
stop=get(stopButton,'UserData');
if stop==1
    stop=1;
else
    stop=0;
end


% --- Executes on button press in connectdaq.
function connectdaq_Callback(hObject, eventdata, handles)
% hObject    handle to connectdaq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
try
    global mydaq
    mydaq=daq.createSession('ni')
    mydaq.addDigitalChannel('myDAQ1','port0/line7','OutputOnly')
    mydaq.addDigitalChannel('myDAQ1','port0/line6','OutputOnly')
    mydaq.addDigitalChannel('myDAQ1','port0/line5','OutputOnly')
    set(handles.messages,'String','Successfully connected to NI MyDAQ')
    set(handles.daqStatus,'ForegroundColor','g')
catch
    set(handles.messages,'String','Error connecting NI MyDAQ')
end
    

% --- Executes on button press in lightswitch.
function lightswitch_Callback(hObject, eventdata, handles)
% hObject    handle to lightswitch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global mydaq
laserState=get(handles.lightswitch,'UserData');
if isempty(laserState)
    laserState=0;
end
if laserState==0
    mydaq.outputSingleScan([1 1 1]);
    set(handles.lightswitch,'UserData',1);
elseif laserState==1
    mydaq.outputSingleScan([0 0 0]);
    set(handles.lightswitch,'UserData',0);
end

% --- Executes on button press in connectdaq.
function disconnectdaq_Callback(hObject, eventdata, handles)
% hObject    handle to connectdaq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global mydaq
mydaq.removeChannel(1);
delete(mydaq)
set(handles.messages,'String','Disconnected MyDAQ')
set(handles.daqStatus,'ForegroundColor','r')

% --- Executes during object creation, after setting all properties.
function lightswitch_CreateFcn(hObject, eventdata, handles)
% hObject    handle to laserSequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function connectdaq_CreateFcn(hObject, eventdata, handles)
% hObject    handle to laserSequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function disconnectdaq_CreateFcn(hObject, eventdata, handles)
% hObject    handle to laserSequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in useSequence.
function useSequence_Callback(hObject, eventdata, handles)
% hObject    handle to useSequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of useSequence
en=get(handles.lightswitch,'Enable');
switch en
    case 'on'
        set(handles.lightswitch,'Enable','off')
        set(handles.sequence1,'Enable','on')
        set(handles.sequence2,'Enable','on')
        set(handles.sequence3,'Enable','on')
        set(handles.ch1,'Enable','on')
        set(handles.ch2,'Enable','on')
        set(handles.ch3,'Enable','on')
        set(handles.showSequenceGraph,'Enable','on')
        set(handles.repeat1,'Enable','on')
        set(handles.repeat2,'Enable','on')
        set(handles.repeat3,'Enable','on')
    case 'off'
        set(handles.lightswitch,'Enable','on')
        set(handles.sequence1,'Enable','off')
        set(handles.sequence2,'Enable','off')
        set(handles.sequence3,'Enable','off')
        set(handles.ch1,'Enable','off')
        set(handles.ch2,'Enable','off')
        set(handles.ch3,'Enable','off')
        set(handles.showSequenceGraph,'Enable','off')
        set(handles.repeat1,'Enable','off')
        set(handles.repeat2,'Enable','off')
        set(handles.repeat3,'Enable','off')
end



function sequence1_Callback(hObject, eventdata, handles)
% hObject    handle to sequence1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sequence1 as text
%        str2double(get(hObject,'String')) returns contents of sequence1 as a double


% --- Executes during object creation, after setting all properties.
function sequence1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sequence1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over seqlength.
function seqlength_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to seqlength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)




% --- Executes on button press in ch1.
function ch1_Callback(hObject, eventdata, handles)
% hObject    handle to ch1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch1


% --- Executes on button press in ch2.
function ch2_Callback(hObject, eventdata, handles)
% hObject    handle to ch2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch2


% --- Executes on button press in ch3.
function ch3_Callback(hObject, eventdata, handles)
% hObject    handle to ch3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch3


% --- Executes on button press in ventralRight.
function ventralRight_Callback(hObject, eventdata, handles)
% hObject    handle to ventralRight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ventralRight
val=get(hObject,'Value');
if val==1
    set(handles.ventralLeft,'Value',0);
    set(handles.noVentral,'Value',0);
elseif val==0
    set(handles.noVentral,'Value',1);
end


% --- Executes on button press in ventralLeft.
function ventralLeft_Callback(hObject, eventdata, handles)
% hObject    handle to ventralLeft (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ventralLeft
val=get(hObject,'Value');
if val==1
    set(handles.ventralRight,'Value',0);
    set(handles.noVentral,'Value',0);
elseif val==0
    set(handles.noVentral,'Value',1);
end

% --- Executes on button press in noVentral.
function noVentral_Callback(hObject, eventdata, handles)
% hObject    handle to noVentral (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of noVentral
val=get(hObject,'Value');
if val==1
    set(handles.ventralLeft,'Value',0);
    set(handles.ventralRight,'Value',0);
elseif val==0
    set(handles.noVentral,'Value',1);
end



function sequence2_Callback(hObject, eventdata, handles)
% hObject    handle to sequence2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sequence2 as text
%        str2double(get(hObject,'String')) returns contents of sequence2 as a double


% --- Executes during object creation, after setting all properties.
function sequence2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sequence2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function sequence3_Callback(hObject, eventdata, handles)
% hObject    handle to sequence3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sequence3 as text
%        str2double(get(hObject,'String')) returns contents of sequence3 as a double


% --- Executes during object creation, after setting all properties.
function sequence3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sequence3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in showSequenceGraph.
function showSequenceGraph_Callback(hObject, eventdata, handles)
% hObject    handle to showSequenceGraph (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ch1=get(handles.ch1,'Value');
ch2=get(handles.ch2,'Value');
ch3=get(handles.ch3,'Value');
rpt1=str2num(get(handles.repeat1,'String'));
rpt2=str2num(get(handles.repeat2,'String'));
rpt3=str2num(get(handles.repeat3,'String'));
rectime=get(handles.rectime,'String'); rectime=str2double(rectime);

if ch1
    seq1=get(handles.sequence1,'String');
    seq1=processSequence(seq1,rpt1,rectime);
else
    seq1=[];
end
while length(seq1)<rectime
    seq1=strcat(seq1,'0');
end

if ch2
    seq2=get(handles.sequence2,'String');
    seq2=processSequence(seq2,rpt2,rectime);
else
    seq2=[];
end
while length(seq2)<rectime
    seq2=strcat(seq2,'0');
end

if ch3
    seq3=get(handles.sequence3,'String');
    seq3=processSequence(seq3,rpt3,rectime);
else
    seq3=[];
end
while length(seq3)<rectime
    seq3=strcat(seq3,'0');
end

stimGraphHandle=stimGraph(seq1,seq2,seq3);

function trackingThreshold_Callback(hObject, eventdata, handles)
% hObject    handle to trackingThreshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of trackingThreshold as text
%        str2double(get(hObject,'String')) returns contents of trackingThreshold as a double



% --- Executes during object creation, after setting all properties.
function trackingThreshold_CreateFcn(hObject, eventdata, handles)
% hObject    handle to trackingThreshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function sequence1_KeyPressFcn(hObject, eventdata, handles)
sequenceScript

function sequence2_KeyPressFcn(hObject, eventdata, handles)
sequenceScript

function sequence3_KeyPressFcn(hObject, eventdata, handles)
sequenceScript



function repeat1_Callback(hObject, eventdata, handles)
% hObject    handle to repeat1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of repeat1 as text
%        str2double(get(hObject,'String')) returns contents of repeat1 as a double


% --- Executes during object creation, after setting all properties.
function repeat1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to repeat1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function repeat2_Callback(hObject, eventdata, handles)
% hObject    handle to repeat2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of repeat2 as text
%        str2double(get(hObject,'String')) returns contents of repeat2 as a double


% --- Executes during object creation, after setting all properties.
function repeat2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to repeat2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function repeat3_Callback(hObject, eventdata, handles)
% hObject    handle to repeat3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of repeat3 as text
%        str2double(get(hObject,'String')) returns contents of repeat3 as a double


% --- Executes during object creation, after setting all properties.
function repeat3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to repeat3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function seqOut=processSequence(seq,repeat,rectime)
if nargin==2
    rectime=[];
end
seqNoSpace=[];
for i=1:length(seq)
    if ~isspace(seq(i))
        seqNoSpace=[seqNoSpace seq(i)];
    end
end
seq=seqNoSpace;
        

asterisk=strfind(seq,'*');
if ~isempty(asterisk)
    segs=strsplit(seq,',');

%     components=[];
    newSeq=[];
    for i=1:length(segs)
        currSeg=segs{i};
        subcomponents=strsplit(currSeg,'*');
        components=[{str2double(subcomponents{1})} subcomponents(2)];
        for i=1:components{1}
            newSeq=strcat(newSeq,components{2});
        end
    end
else
    newSeq=seq;
end
seqOut=[];
for i=1:repeat
    seqOut=strcat(seqOut,newSeq);
end

if ~isempty(rectime)
    while length(seqOut)<rectime
        seqOut=strcat(seqOut,'0');
    end
    if length(seqOut)>rectime
        seqOut=seqOut(1:rectime);
    end
end


function repeat1_KeyPressFcn(hObject, eventdata, handles)
sequenceScript

function repeat2_KeyPressFcn(hObject, eventdata, handles)
sequenceScript

function repeat3_KeyPressFcn(hObject, eventdata, handles)
sequenceScript



function comPort_Callback(hObject, eventdata, handles)
% hObject    handle to comPort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of comPort as text
%        str2double(get(hObject,'String')) returns contents of comPort as a double


% --- Executes during object creation, after setting all properties.
function comPort_CreateFcn(hObject, eventdata, handles)
% hObject    handle to comPort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
