dontSegment=get(handles.dontSegment,'Value');

%inputs include currFrame and splineData
framesA=(currFrame-1)*2+1:(currFrame-1)*2+2; frameNumA=currFrame;
framesB=currFrame*2+1:currFrame*2+2; frameNumB=currFrame+1;
framesC=(currFrame+1)*2+1:(currFrame+1)*2+2; frameNumC=currFrame+2;
framesD=(currFrame+2)*2+1:(currFrame+2)*2+2; frameNumD=currFrame+3;
totFrames=length(splineData(:,1))/2;

curveOverrides=get(handles.fixA,'UserData');

%panel A
axes(handles.panelA);cla;title('');set(handles.infoA,'String','');axis auto;hold on
if frameNumA<=totFrames
    set(handles.curveA,'Visible','On');
    x=splineData(framesA(1),:);
    y=splineData(framesA(2),:);
    ventralDir=ventralData(frameNumA);
    if ~isempty(curveOverrides)
        overrideLocs=find(frameNumA==curveOverrides(:,1));
        if isempty(overrideLocs)
            [curvature,vd]=wormCurvature(x,y,ventralDir,[],dontSegment);
        else
            [curvature,vd]=wormCurvature(x,y,ventralDir,curveOverrides(overrideLocs,2:end),dontSegment);
        end
    else
        [curvature,vd]=wormCurvature(x,y,ventralDir,[],dontSegment);
    end
    title(['Frame ' num2str(frameNumA) '/' num2str(totFrames)])
    curvString=[];
    for i=1:length(curvature)
        curvPercent=[num2str(round(1000*curvature(i))/10) '%'];
        newCurvString=['Curve ' num2str(i) ': ' curvPercent '  '];
        curvString=[curvString newCurvString];
    end

    set(handles.infoA,'String',curvString)

    curveNum=curveData(frameNumA);
    
    if curveNum==0
        curveNumStr='#';
    else
        curveNumStr=num2str(curveNum);
    end
    set(handles.curveA,'String',curveNumStr);
else
    set(handles.curveA,'Visible','Off');
end
hold off

%panel B
axes(handles.panelB);cla;title('');set(handles.infoB,'String','');axis auto;hold on
if frameNumB<=totFrames
    set(handles.curveB,'Visible','On');
    x=splineData(framesB(1),:);
    y=splineData(framesB(2),:);
    ventralDir=ventralData(frameNumB);
    if ~isempty(curveOverrides)
        overrideLocs=find(frameNumB==curveOverrides(:,1));
        if isempty(overrideLocs)
            [curvature,vd]=wormCurvature(x,y,ventralDir,[],dontSegment);
        else
            [curvature,vd]=wormCurvature(x,y,ventralDir,curveOverrides(overrideLocs,2:end),dontSegment);
        end
    else
        [curvature,vd]=wormCurvature(x,y,ventralDir,[],dontSegment);
    end
    title(['Frame ' num2str(frameNumB) '/' num2str(totFrames)])
    curvString=[];
    for i=1:length(curvature)
        curvPercent=[num2str(round(1000*curvature(i))/10) '%'];
        newCurvString=['Curve ' num2str(i) ': ' curvPercent '  '];
        curvString=[curvString newCurvString];
    end

    set(handles.infoB,'String',curvString)

    curveNum=curveData(frameNumB);
    
    if curveNum==0
        curveNumStr='#';
    else
        curveNumStr=num2str(curveNum);
    end
    set(handles.curveB,'String',curveNumStr);
else
    set(handles.curveB,'Visible','Off');
end
hold off

%panel C
axes(handles.panelC);cla;title('');set(handles.infoC,'String','');axis auto;hold on
if frameNumC<=totFrames
    set(handles.curveC,'Visible','On');
    x=splineData(framesC(1),:);
    y=splineData(framesC(2),:);
    ventralDir=ventralData(frameNumC);
    if ~isempty(curveOverrides)
        overrideLocs=find(frameNumC==curveOverrides(:,1));
        if isempty(overrideLocs)
            [curvature,vd]=wormCurvature(x,y,ventralDir,[],dontSegment);
        else
            [curvature,vd]=wormCurvature(x,y,ventralDir,curveOverrides(overrideLocs,2:end),dontSegment);
        end
    else
        [curvature,vd]=wormCurvature(x,y,ventralDir,[],dontSegment);
    end
    title(['Frame ' num2str(frameNumC) '/' num2str(totFrames)])
    curvString=[];
    for i=1:length(curvature)
        curvPercent=[num2str(round(1000*curvature(i))/10) '%'];
        newCurvString=['Curve ' num2str(i) ': ' curvPercent '  '];
        curvString=[curvString newCurvString];
    end

    set(handles.infoC,'String',curvString)

    curveNum=curveData(frameNumC);

    if curveNum==0
        curveNumStr='#';
    else
        curveNumStr=num2str(curveNum);
    end
    set(handles.curveC,'String',curveNumStr);
else
    set(handles.curveC,'Visible','Off');
end
hold off

%panel D
axes(handles.panelD);cla;title('');set(handles.infoD,'String','');axis auto;hold on
if frameNumD<=totFrames
    set(handles.curveD,'Visible','On');
    x=splineData(framesD(1),:);
    y=splineData(framesD(2),:);
    ventralDir=ventralData(frameNumD);
    if ~isempty(curveOverrides)
        overrideLocs=find(frameNumD==curveOverrides(:,1));
        if isempty(overrideLocs)
            [curvature,vd]=wormCurvature(x,y,ventralDir,[],dontSegment);
        else
            [curvature,vd]=wormCurvature(x,y,ventralDir,curveOverrides(overrideLocs,2:end),dontSegment);
        end
    else
        [curvature,vd]=wormCurvature(x,y,ventralDir,[],dontSegment);
    end
    title(['Frame ' num2str(frameNumD) '/' num2str(totFrames)])
    curvString=[];
    for i=1:length(curvature)
        curvPercent=[num2str(round(1000*curvature(i))/10) '%'];
        newCurvString=['Curve ' num2str(i) ': ' curvPercent '  '];
        curvString=[curvString newCurvString];
    end

    set(handles.infoD,'String',curvString)

    curveNum=curveData(frameNumD);

    if curveNum==0
        curveNumStr='#';
    else
        curveNumStr=num2str(curveNum);
    end
    set(handles.curveD,'String',curveNumStr);
else
    set(handles.curveD,'Visible','Off');
end
hold off

%final interface operations
if currFrame+3>totFrames
    lastFrame=totFrames;
else
    lastFrame=currFrame+3;
end
set(handles.currFrame,'UserData',currFrame:lastFrame);
set(handles.currFrame,'String',[num2str(currFrame) '-' num2str(lastFrame)]);
if currFrame==1
    set(handles.back,'Visible','Off');
else
    set(handles.back,'Visible','On');
end

if currFrame+3>=totFrames
    set(handles.forward,'Visible','Off');
else
    set(handles.forward,'Visible','On');
end