function [freq,time,head]=fftscript(filename,bendNumber,fs,framesToAnalyze,doPlot)

if nargin==4
    doPlot=0;
end

%fftscript
[x,y,ventralData]=plotWormPath(filename,1:13);
close(gcf)
if ~strcmp(framesToAnalyze,'all')
    x=x(framesToAnalyze(1):framesToAnalyze(2),:);
    y=y(framesToAnalyze(1):framesToAnalyze(2),:);
end


bend=[];
for i=1:length(x(:,1));
    bends=wormBends2(x(i,:),y(i,:),2:12);
    bend=[bend;bends];
end
head=bend(:,bendNumber);
head=[head; zeros(1000,1)];
H=abs(fft(head));
df=fs/(length(H)-1);
f=0:df:fs;

if doPlot
    figure;
    plot(f,abs(H))
    xlabel('Frequency (Hz)')
    ylabel('Magnitude')
    title('Frequency spectrum')
end

% fig=figure;
time=0:length(head)-1;
time=time/fs;
% plot(time,head);
% hold on
% line([0 max(time)],[0 0],'Color','k');
% hold off

lowerLim=find(f>0.1);
lowerLim=lowerLim(1);
H(1:lowerLim)=0;
i=find(H(1:end/2)==max(H(1:round(end/2))));     %added this "round" function 4/4/13 but for some reason still can't suppress warnings.
peak=max(H(1:round(end/2)));
freq=f(i);
head=head(1:end-1000);
time=time(1:length(head));
% disp(freq);
% pos=get(fig,'Position');
% set(fig,'Position',[200 200 1200 800]);
% ahead=abs(head);
% m=mean(ahead(ahead>10));
% disp(m)