function varargout = playback_gui(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @playback_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @playback_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function playback_gui_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;

guidata(hObject, handles);

function varargout = playback_gui_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;

function pause_Callback(hObject, eventdata, handles)
set(hObject,'UserData',1);

function play_Callback(hObject, eventdata, handles)
set(handles.pause,'UserData',0)
f=get(handles.currFrame,'UserData');
frameRate=str2double(get(handles.frameRate,'String'));
filelist=get(handles.load,'UserData');
totalFrames=length(filelist);
while f<=totalFrames && ~get(handles.pause,'UserData')
    showFrame(f,handles);
    f=f+1;
    pause(1/frameRate);
end

function nextFrame_Callback(hObject, eventdata, handles)
f=get(handles.currFrame,'UserData');
try
    f=f+1;
    showFrame(f,handles);
catch
end

function prevFrame_Callback(hObject, eventdata, handles)
f=get(handles.currFrame,'UserData');
try
    f=f-1;
    showFrame(f,handles);
catch
end

function frameRate_Callback(hObject, eventdata, handles)

function frameRate_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function path_Callback(hObject, eventdata, handles)

function path_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function browse_Callback(hObject, eventdata, handles)
persistent lastPath
if isempty(lastPath)
    pathname=uigetdir();
else
    try
        pathname=uigetdir(lastPath);
    catch
        pathname=uigetdir();
    end
end

comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end


if ~isnumeric(pathname)
    set(handles.path,'String',pathname)
    lastSlash=find(pathname==slash);
    lastSlash=lastSlash(end);
    stageName=[pathname slash pathname(lastSlash+1:end) '.txt'];
    set(handles.stagePath,'String',stageName);
end
lastPath=pathname;

function load_Callback(hObject, eventdata, handles)
path=get(handles.path,'String');
fixNumbers(path);
filelist=listBmpsInFolder(path);
% filelist=filelist(21:5:end);
totalFiles=length(filelist);
set(handles.load,'UserData',filelist);
set(handles.frameInfo,'String',num2str(totalFiles));
showFrame(1,handles);

function filelist=listBmpsInFolder(path)
comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end

list=dir([path slash '*.bmp']);
filelist=[];
for i=1:length(list)
    filelist=[filelist; {[path slash list(i).name]}];
end

function showFrame(number,handles)

% persistent frames;

filelist=get(handles.load,'UserData');
% disp(filelist{number});
origfile=[get(handles.path,'string') '_spline_orig.txt'];

showSpline=get(handles.showSpline,'value');
if showSpline
    try
        % splinelist=load('E:\recordings 7-7-10\inx18-5_spline_orig.txt');
        splinelist=load(origfile);
        did=1;
    catch
        did=0;
    end
else
    did=0;
end

if get(handles.showThresholdImage,'Value')
    threshold=str2double(get(handles.threshold,'String'));
    [imgFilled,img,imgSub,possibleOmega]=prepImage(filelist{number},0,1,threshold);
    img=1-img;
else
    img=imread(filelist{number});
    img=img(1:end,1:end,1);
end
axes(handles.win)

% tempFig=figure;

imshow(img)

if did==1
    hold on
    x=splinelist(2*number-1,2:14);
    y=splinelist(2*number,2:14);
    plot(x,480-y+1,'c.-');
    plot(x(1),480-y(1)+1,'r.','MarkerSize',12);
    plot(x(end-2:end),480-y(end-2:end)+1,'m')
    plot(x(1:2),480-y(1:2)+1,'r')
    hold off
    xlim([1 640]);
    ylim([1 480]);
%     disp(splinelist(2*number-1,1));
%     disp(splinelist(2*number,1));
end

% tempstr=['im' num2str(number) '.tif']

set(handles.currFrame,'String',num2str(number));
% set(handles.frameInfo,'String',[num2str(number) ' / ' num2str(totalFiles)]);
set(handles.currFrame,'UserData',number);


function currFrame_Callback(hObject, eventdata, handles)

function currFrame_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function jumpToFrame_Callback(hObject, eventdata, handles)
frame=str2double(get(handles.currFrame,'String'));
showFrame(frame,handles);


function showThresholdImage_Callback(hObject, eventdata, handles)


function threshold_Callback(hObject, eventdata, handles)

function threshold_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function f1_Callback(hObject, eventdata, handles)

function f1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function f2_Callback(hObject, eventdata, handles)

function f2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function cut_Callback(hObject, eventdata, handles)
comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end

filelist=get(handles.load,'UserData');
f1=str2double(get(handles.f1,'String'));
f2=str2double(get(handles.f2,'String'));
path=get(handles.path,'String');
mkdir([path slash 'removed']);
stagePath=get(handles.stagePath,'String');
stageMovement=load(stagePath);
copyfile(stagePath,[stagePath(1:end-4) '_orig.txt']);
frameRate=str2double(get(handles.frameRate,'String'));
if f1~=1  %this needs to be fixed to be true for all frame rates... too lazy to do it now.
    linesToRemove=(f1-frameRate-1)/frameRate;    
    newStageMovement=stageMovement([1 linesToRemove+2:end],:);
elseif f1==1
    newStageMovement=[0 0;stageMovement];
    msgbox(['If data was recorded prior to 6-23-10, an incompatibility may'...
        ' exist in which the first 2 seconds of data do not contain valid'...
        ' positional data.  Bending analysis remains valid.  To avoid this'...
        ' issue in data taken prior to 6-23-10, cut the recording from frames 2*fs+1'...
        ' or after--i.e. if fs=15, cut from frame 31 and after.'],'Warning');
end
labels=[{'%%delta-x'} {'%%delta-y'}];
saveDataMatrix(labels,newStageMovement,stagePath);

if f1~=1
    for i=1:f1-1
        movefile(filelist{i},[path slash 'removed'])
    end
end

if f2~=length(filelist)
    for i=f2+1:length(filelist)
        movefile(filelist{i},[path slash 'removed'])
    end
end

disp('Cutting Done')

function stagePath_Callback(hObject, eventdata, handles)

function stagePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function browseStagePath_Callback(hObject, eventdata, handles)
[filename pathname]=uigetfile('*.txt','Open Stage File');
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.stagePath,'String',[pathname filename]);
end


function path_KeyPressFcn(gcbo, eventdata, handles)
comp=computer;
if ~strcmp(comp,'PCWIN64') && ~strcmp(comp,'PCWIN32')
    slash='/';
else
    slash='\';
end

if strcmp(eventdata.Key,'return')
    pause(.5)
    flashBox(handles.stagePath);
    pathname=get(handles.path,'String');
    lastSlash=find(pathname==slash);
    lastSlash=lastSlash(end);
    stageName=[pathname slash pathname(lastSlash+1:end) '.txt'];
    set(handles.stagePath,'String',stageName);
end


function reduceFrameRate_Callback(hObject, eventdata, handles)
pathname=get(handles.path,'String');
cutFrames_gui(pathname)


% --- Executes on button press in showSpline.
function showSpline_Callback(hObject, eventdata, handles)
% hObject    handle to showSpline (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showSpline



function movieFrameStart_Callback(hObject, eventdata, handles)
% hObject    handle to movieFrameStart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of movieFrameStart as text
%        str2double(get(hObject,'String')) returns contents of movieFrameStart as a double


% --- Executes during object creation, after setting all properties.
function movieFrameStart_CreateFcn(hObject, eventdata, handles)
% hObject    handle to movieFrameStart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function movieFrameEnd_Callback(hObject, eventdata, handles)
% hObject    handle to movieFrameEnd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of movieFrameEnd as text
%        str2double(get(hObject,'String')) returns contents of movieFrameEnd as a double


% --- Executes during object creation, after setting all properties.
function movieFrameEnd_CreateFcn(hObject, eventdata, handles)
% hObject    handle to movieFrameEnd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in movieFormat.
function movieFormat_Callback(hObject, eventdata, handles)
% hObject    handle to movieFormat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns movieFormat contents as cell array
%        contents{get(hObject,'Value')} returns selected item from movieFormat


% --- Executes during object creation, after setting all properties.
function movieFormat_CreateFcn(hObject, eventdata, handles)
% hObject    handle to movieFormat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function moviePath_Callback(hObject, eventdata, handles)
% hObject    handle to moviePath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of moviePath as text
%        str2double(get(hObject,'String')) returns contents of moviePath as a double


% --- Executes during object creation, after setting all properties.
function moviePath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to moviePath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in browseMoviePath.
function browseMoviePath_Callback(hObject, eventdata, handles)
[filename pathname]=uiputfile('*.avi','Save Movie As');
if ~isnumeric(filename) && ~isnumeric(pathname)
    set(handles.moviePath,'String',[pathname filename]);
end

% --- Executes on button press in movieExport.
function movieExport_Callback(hObject, eventdata, handles)

startFrame=str2num(get(handles.movieFrameStart,'String'));
endFrame=str2num(get(handles.movieFrameEnd,'String'));
filelist=get(handles.load,'UserData');
moviePath=get(handles.moviePath,'String');
frameRate=str2num(get(handles.frameRate,'String'));

totalFrames=endFrame-startFrame+1;

showSpline=get(handles.showSpline,'value');
origfile=[get(handles.path,'string') '_spline_orig.txt'];
if showSpline
    try
        % splinelist=load('E:\recordings 7-7-10\inx18-5_spline_orig.txt');
        splinelist=load(origfile);
        did=1;
    catch
        did=0;
    end
else
    did=0;
end



writerObj=VideoWriter(moviePath);
writerObj.FrameRate=frameRate;
open(writerObj);
if did
    hf=figure;
end
for i=startFrame:endFrame
    frame=imread(filelist{i});
%     hf=figure;
    
    if did==1
        figure(hf)
        imshow(frame)
        hold on
        x=splinelist(2*i-1,2:14);
        y=splinelist(2*i,2:14);
        plot(x,480-y+1,'c.-');
        plot(x(1),480-y(1)+1,'r.','MarkerSize',12);
        plot(x(end-2:end),480-y(end-2:end)+1,'m')
        plot(x(1:2),480-y(1:2)+1,'r')
        hold off
        xlim([1 640]);
        ylim([1 480]);
        frame=getframe(gca);
        frame=frame.cdata;
        frame=frame(:,1:end-1,:);
%         close(hf)
    end
    
    writeVideo(writerObj,frame);
    progress=round(i/totalFrames*100);
    progress=[num2str(progress) '%'];
    set(handles.movieProgress,'String',progress);
    drawnow
end
if did
    close(hf)
end
close(writerObj);
% image1=imread(filelist{startFrame});
% mov=zeros([size(image1) endFrame-startFrame+1],class(image1));

% the below code runs fine but runs out of memory with large sets of data

% totalFrames=endFrame-startFrame+1;
% for i=startFrame:endFrame
%     currFrame=imread(filelist{i});
%     mov(:,:,i)=currFrame;
%     progress=i/totalFrames*100;
%     progress=round(progress*100)/100;
%     progress=[num2str(progress) '%'];
%     set(handles.movieProgress,'String',progress);
% end


% mov=permute(mov,[1 2 4 3]);
% mov=immovie(mov,gray);
% implay(mov)
