function [curvature,vd]=wormCurvature(x,y,ventralDir,override,dontSegment,makePlot)

if nargin==5
    makePlot=1;
end

if ~isempty(override)
    overriddenCurves=override(:,1);
else
    overriddenCurves=[];
end

colors='rmb';
%first draw a line from head to tail of worm
dx=x(end)-x(1);
dy=y(end)-y(1);
lx=[x(1)-dx x(1) x(end) x(end)+dx];
ly=[y(1)-dy y(1) y(end) y(end)+dy];
slope=[dx dy];
slope=slope/norm(slope);
perpslope=[-slope(2) slope(1)];

headTailDist=ptDist(x(1),y(1),x(end),y(end));

x=interp(x,9);
y=interp(y,9);
x=x(1:5:end);
y=y(1:5:end);
L=wormLength(x,y);

if ~dontSegment

    [Ir,polarity]=findInflectionPoints(x,y);


    % plot(x,y,'b','LineWidth',2);
    r=zeros(1,length(Ir)-1);
    rl=r;
    lastcw=0;
    pointList=[];
    if makePlot
        plot(x(1),y(1),'rx','MarkerSize',15)
    end
    for i=1:length(Ir)-1
        currColor=mod(i,3); 
        if currColor==0
            currColor=3;
        end
        tempx=x(Ir(i):Ir(i+1));
        tempy=y(Ir(i):Ir(i+1));

        if makePlot
            plot(tempx,tempy,colors(currColor),'LineWidth',2)
        end

        XY=[tempx' tempy'];
        par=CircleFitByKasa(XY);
        a=par(1);b=par(2);r(i)=par(3);
        thetas=0:.05:2*pi;
        cx=a+r(i)*cos(thetas);
        cy=b+r(i)*sin(thetas);

        cw=isClockwise(tempx,tempy);
        rl=r(i)/L;

        if i~=1
            magdiff=cw-lastcw;
    %         radDiff=abs(rl-lastrl);
            if magdiff==0 % && radDiff<.1
                if i==2
                    pointList=[pointList(i-1,1) Ir(i+1)];
                else
                    pointList=[pointList(1:end-1,:); pointList(end,1) Ir(i+1)];
                end
            elseif magdiff~=0 %|| radDiff>=.1
                pointList=[pointList; Ir(i) Ir(i+1)];
                lastcw=cw;
            end

        else
            lastcw=cw;
    %         lastrl=rl;
            pointList=[Ir(1) Ir(2)];
        end
    end
elseif dontSegment
    pointList=[1 length(x)];
    if makePlot
        plot(x,y,'LineWidth',2)
        plot(x(1),y(1),'rx','MarkerSize',16)
    end
end

if makePlot
    xl=get(gca,'XLim');
    yl=get(gca,'YLim');
end

% rl=r/L;
% for i=1:length(pointList(:,1))
%     startPt=pointList(i,1);
%     endPt=pointList(i,2);
%     startPtIr=find(Ir==startPt);
%     if endPt~=Ir(startPtIr+1);
%         pointsIncluded=find(Ir==startPt):find(Ir==endPt);
%         radiusesIncluded=rl(pointsIncluded(1):pointsIncluded(end-1));
%         pointsIncludedNew=[];
%         for j=1:length(radiusesIncluded)
%             if radiusesIncluded(j)<.5
%                 pointsIncludedNew=[pointsIncludedNew;pointsIncluded(j:j+1)];
%             end
%             
%         end
%         pointsIncludedNew=Ir(pointsIncludedNew);
%         pointList=[pointList(1:i-1,:); pointsIncludedNew; pointList(i+1:end,:)];
%     end
% 
% end



rPrime=[];
vd=[];
for i=1:length(pointList(:,1))
    pointA=pointList(i,1);
    pointB=pointList(i,2);
    ab=[pointA:pointB];
    tempx=x(ab);
    tempy=y(ab);
    XY=[tempx' tempy'];
    par=CircleFitByKasa(XY);
    a=par(1);b=par(2);r=par(3);
    


    rL=r/L;
    wl=wormLength(tempx,tempy);
    if rL>0.01 && rL<.8 && wl>3
        
        if isClockwise(tempx,tempy) && ventralDir==1
            dir='-.'; %dorsal
            vd=[vd; -1];
        elseif isClockwise(tempx,tempy) && ventralDir==2
            dir='-'; %ventral
            vd=[vd; 1];
        elseif ~isClockwise(tempx,tempy) && ventralDir==1
            dir='-'; %ventral
            vd=[vd; 1];
        elseif ~isClockwise(tempx,tempy) && ventralDir==2
            dir='-.'; %dorsal
            vd=[vd; -1];
        elseif ventralDir==0
            dir=':'; %undecided
            vd=[vd; 0];
        end
        
        rPrime=[rPrime rL];
        
        overridePresent=find(length(rPrime)==overriddenCurves);
        if ~isempty(overridePresent)
            if length(overridePresent)>1
                overridePresent=max(overridePresent);
            end
            a=override(overridePresent,2);
            b=override(overridePresent,3);
            r=override(overridePresent,4);
            rL=r/L; rPrime(end)=rL;
            d=override(overridePresent,5);
            switch d
                case 1 %ventral
                    dir='-';
                    vd(end)=1;
                case -1 % dorsal
                    dir='-.';
                    vd(end)=-1;
                case 0 %undecided
                    dir=':';
                    vd(end)=0;
            end
        end
        
        
        thetas=0:.05:2*pi;
        cx=a+r*cos(thetas);
        cy=b+r*sin(thetas);
        if makePlot
            plot(cx,cy,'k','LineStyle',dir);

            if a<xl(2) && a>xl(1)
                xpos=a;
            elseif a<xl(1)
                xpos=xl(1);
            elseif a>xl(2)
                xpos=xl(2);
            end
            if b<yl(2) && b>yl(1)
                ypos=b;
            elseif b<yl(1)
                ypos=yl(1);
            elseif b>yl(2)
                ypos=yl(2);
            end        
            text(xpos,ypos,num2str(length(rPrime)),'FontSize',10)
        end
    end
end

if makePlot
    set(gca,'XLim',[xl(1)*.95 xl(2)*1.05]);
    set(gca,'YLim',[yl(1)*.95 yl(2)*1.05]);
end

curvature=rPrime;

function [Ir,polarity]=findInflectionPoints(x,y)
Ir=[1];
polarity=[];
for i=2:length(x)-1
    va=[x(i)-x(i-1) y(i)-y(i-1) 0];
    vb=[x(i+1)-x(i) y(i+1)-y(i) 0];
    cp=cross(va,vb);
    magCP=sign(cp(3));

    if i==2
        lastCP=magCP;
        polarity=magCP;
    elseif magCP-lastCP==0
        
    elseif magCP-lastCP~=0
        Ir=[Ir i];
        lastCP=magCP;
        polarity=[polarity magCP];
    end
end
Ir=[Ir length(x)];